<?php
/* 
Plugin Name: Shantz Wordpress Prefix Suffix
Plugin URI: http://tech.shantanugoel.com/projects/wordpress/shantz-wordpress-prefix-suffix
Version: 1.0.4
Author: Shantanu Goel
Author URI: http://blog.shantanugoel.com
Description: This plugin shall give you the ability to add any text/HTML/CSS code to the beginning or end of your posts and/or pages. Go to <a href="http://tech.shantanugoel.com/projects/wordpress/shantz-wordpress-prefix-suffix">shantz-wp-prefix-suffix</a> for updates and support. Also visit my <a href="http://tech.shantanugoel.com">tech site</a>.
 
Copyright 2007  Shantanu Goel  (email : shantanu [a t ] shantanugoel DOT com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
if (!class_exists("shantzWpSuffPref")) {
	class shantzWpSuffPref {
        var $adminOptionsName = "shantzWpSuffPrefAdminOptions";
        var $wpCompat;

		function shantzWpSuffPref() { //constructor
			
		}

	function getAdminOptions() {
            $shantzAdminOptions = array('post_prefix' => '',
		'post_sufffix' => '',
		'post_prefix_post' => 'true',
		'post_prefix_page' => 'true',
		'post_prefix_php' => 'true',
		'post_suffix_post' => 'true',
		'post_suffix_page' => 'true',
		'post_suffix_php' => 'true');

            $shantzOptions = get_option($this->adminOptionsName);
            if (!empty($shantzOptions)) {
                foreach ($shantzOptions as $key => $option)
                    $shantzAdminOptions[$key] = $option;
            }
            update_option($this->adminOptionsName, $shantzAdminOptions);
            return $shantzAdminOptions;
        }

        function init() {
            $this->getAdminOptions();
        }

        function printAdminPage() {
            $shantzOptions = $this->getAdminOptions();

            if(isset($_POST['defaults_shantzWpSuffPrefSettings'])) {
                    $shantzOptions['post_prefix'] = '';
                    $shantzOptions['post_suffix'] = '';
		    $shantzOptions['post_prefix_post'] = 'true';
		    $shantzOptions['post_prefix_page'] = 'true';
		    $shantzOptions['post_prefix_php'] = 'true';
		    $shantzOptions['post_suffix_post'] = 'true';
		    $shantzOptions['post_suffix_page'] = 'true';
		    $shantzOptions['post_suffix_php'] = 'true';

                update_option($this->adminOptionsName, $shantzOptions);

                ?>
                    <div class="updated"><p><strong><?php _e("Settings Reset to Defaults.", "shantzWpSuffPref");?></strong></p></div>
                    <?php
            }

            else if(isset($_POST['update_shantzWpSuffPrefSettings'])) {
             if(isset($_POST['shantzWpPrefix'])) {
                $shantzOptions['post_prefix'] = stripslashes(apply_filters('content_save_pre', $_POST['shantzWpPrefix']));
            }
             if(isset($_POST['shantzWpSuffix'])) {
                $shantzOptions['post_suffix'] = stripslashes(apply_filters('content_save_pre', $_POST['shantzWpSuffix']));
            }
             if(isset($_POST['shantzWpPrefixPost'])) {
                $shantzOptions['post_prefix_post'] =  $_POST['shantzWpPrefixPost'];
            }
             if(isset($_POST['shantzWpPrefixPage'])) {
                $shantzOptions['post_prefix_page'] =  $_POST['shantzWpPrefixPage'];
            }
             if(isset($_POST['shantzWpPrefixPhp'])) {
                $shantzOptions['post_prefix_php'] =  $_POST['shantzWpPrefixPhp'];
            }
             if(isset($_POST['shantzWpSuffixPost'])) {
                $shantzOptions['post_suffix_post'] =  $_POST['shantzWpSuffixPost'];
            }
             if(isset($_POST['shantzWpSuffixPage'])) {
                $shantzOptions['post_suffix_page'] =  $_POST['shantzWpSuffixPage'];
            }
             if(isset($_POST['shantzWpSuffixPhp'])) {
                $shantzOptions['post_suffix_php'] =  $_POST['shantzWpSuffixPhp'];
            }

            update_option($this->adminOptionsName, $shantzOptions);

            ?>
<div class="updated"><p><strong><?php _e("Settings Updated.", "shantzWpSuffPref");?></strong></p></div>
            <?php
        } ?>
<div class=wrap>
<form method="post" action="<?php echo $_SERVER["REQUEST_URI"]; ?>">
<h2>Shantanu's WP Prefix Suffix Plugin</h2>
<h3>Go to <a href="http://tech.shantanugoel.com/projects/wordpress/shantz-wordpress-prefix-suffix">shantz-wp-prefix-suffix</a> for updates and support. Also visit my <a href="http://tech.shantanugoel.com">tech site</a>.<h3><br>

<h4>Add the following text before the posts (Prefix) </h4>
<textarea name="shantzWpPrefix" style="width: 100%; height: 50px;"><?php _e(apply_filters('format_to_edit',$shantzOptions['post_prefix']), 'shantzWpSuffPref') ?></textarea>
<p>
<label for="shantzWpPrefixPhp"> Enable PHP Input <input type="hidden" name="shantzWpPrefixPhp" value="false"/><input type="checkbox" name="shantzWpPrefixPhp" value="true" <?php if ($shantzOptions['post_prefix_php'] == "true") { _e('checked="checked"');} ?>/> &nbsp;&nbsp;&nbsp;&nbsp;</label>
<label for="shantzWpPrefixPost"> Add prefix to posts? <input type="hidden" name="shantzWpPrefixPost" value="false"/><input type="checkbox" name="shantzWpPrefixPost" value="true" <?php if ($shantzOptions['post_prefix_post'] == "true") { _e('checked="checked"');} ?>/> &nbsp;&nbsp;&nbsp;&nbsp;</label>
<label for="shantzWpPrefixPage"> Add prefix to pages? <input type="hidden" name="shantzWpPrefixPage" value="false"/><input type="checkbox" name="shantzWpPrefixPage" value="true" <?php if ($shantzOptions['post_prefix_page'] == "true") { _e('checked="checked"');} ?>/> </label>
</p>

<h4>Add the following text after the posts (Suffix) </h4>
<textarea name="shantzWpSuffix" style="width: 100%; height: 50px;"><?php _e(apply_filters('format_to_edit',$shantzOptions['post_suffix']), 'shantzWpSuffPref') ?></textarea>
<p>
<label for="shantzWpSuffixPhp"> Enable PHP Input <input type="hidden" name="shantzWpSuffixPhp" value="false"/><input type="checkbox" name="shantzWpSuffixPhp" value="true" <?php if ($shantzOptions['post_suffix_php'] == "true") { _e('checked="checked"');} ?>/> &nbsp;&nbsp;&nbsp;&nbsp;</label>
<label for="shantzWpSuffixPost"> Add suffix to posts? <input type="hidden" name="shantzWpSuffixPost" value="false"/><input type="checkbox" name="shantzWpSuffixPost" value="true" <?php if ($shantzOptions['post_suffix_post'] == "true") { _e('checked="checked"');} ?>/> &nbsp;&nbsp;&nbsp;&nbsp;</label>
<label for="shantzWpSuffixPage"> Add suffix to pages? <input type="hidden" name="shantzWpSuffixPage" value="false"/><input type="checkbox" name="shantzWpSuffixPage" value="true" <?php if ($shantzOptions['post_suffix_page'] == "true") { _e('checked="checked"');} ?>/> </label>
</p>

<div class="submit">
<input type="submit" name="defaults_shantzWpSuffPrefSettings" value="<?php _e('Load Default Settings', 'shantzWpSuffPref') ?>" />
<input type="submit" name="update_shantzWpSuffPrefSettings" value="<?php _e('Update Settings', 'shantzWpSuffPref') ?>" /></div>
</form>
 </div>
					<?php
	}//End function printAdminPage()

        function addContent($content = '') {
            global $wp_version;
	    global $post;
        $wpCompat = (version_compare($wp_version, '2.1', '<'));
	    $result_pre = 'true';
	    $result_suf = 'true';
            $shantzOptions = $this->getAdminOptions();
		if( (!$wpCompat && ($post->post_type == 'post')) || ($wpCompat && ($post->post_status == 'static')) )  {
		    if ($shantzOptions['post_prefix_post'] == 'false') {
			$result_pre = 'false';
		    }
		    if ($shantzOptions['post_suffix_post'] == 'false') {
			$result_suf = 'false';
		    }
		}
		else {
		    if ($shantzOptions['post_prefix_page'] == 'false') {
			$result_pre = 'false';
		    }
		    if ($shantzOptions['post_suffix_page'] == 'false') {
			$result_suf = 'false';
		    }
		}

        $prefix = $shantzOptions['post_prefix'];
        if($shantzOptions['post_prefix_php'] == 'true') {
            ob_start();
            $ev_result = eval("?>".$prefix."<?");
            if($ev_result !== FALSE)
            {
                $prefix = ob_get_contents();
            }
            ob_end_clean();
        }

	    if ($result_pre == 'true')
	    {
            	$content = $prefix.$content;
	    }

        $suffix = $shantzOptions['post_suffix'];
        if($shantzOptions['post_suffix_php'] == 'true') {
            ob_start();
            $ev_result = eval("?>".$suffix."<?");
            if($ev_result !== FALSE)
            {
                $suffix = ob_get_contents();
            }
            ob_end_clean();
        }

	    if ($result_suf == 'true')
	    {
            	$content = $content.$suffix;
	    }
            return $content;
        }

} //End Class shantz-plugin
}

//Init the admin panel
if (!function_exists("shantzWpSuffPref_ap")) {
    function shantzWpSuffPref_ap() {
        global $shantzWpSuffPrefInstance;
        if(!isset($shantzWpSuffPrefInstance)) {
            return;
        }
        if (function_exists('add_options_page')) {
            add_options_page('Shantanu\'s WP Prefix Suffix Settings', 'Shantz WP Prefix Suffix', 9, basename(__FILE__), array($shantzWpSuffPrefInstance, 'printAdminPage'));
        }
    }
}

if (class_exists("shantzWpSuffPref")) {
	$shantzWpSuffPrefInstance = new shantzWpSuffPref();
}

//Actions and Filters	
if (isset($shantzWpSuffPrefInstance)) {

    add_action('admin_menu', 'shantzWpSuffPref_ap');
    add_action('activate_shantz-wp-prefix-suffix/shantz-wp-prefix-suffix.php', array(&$shantzWpSuffPrefInstance, 'init'));

    add_filter('the_content', array(&$shantzWpSuffPrefInstance, 'addContent'));
}
?>
